/*
 * arch/ppc/platforms/argan_serial.h
 * 
 * Definitions for IBM Argan 
 *
 * Author: <source@mvista.com>
 *
 * Based on code done by Mark A. Greer <mgreer@mvista.com>
 *
 * <2004> (c) MontaVista Software, Inc. This file is licensed under
 * the terms of the GNU General Public License version 2. This program
 * is licensed "as is" without any warranty of any kind, whether express
 * or implied.
 */

#ifndef __PPC_PLATFORMS_ARGAN_SERIAL_H
#define __PPC_PLATFORMS_ARGAN_SERIAL_H

#include <linux/config.h>
#include <platforms/argan.h>

/*
 * Board-specific IRQ info
 */

#define ARGAN_UART0_IO_BASE	ARGAN_UART_BASE+8
#define ARGAN_UART1_IO_BASE	ARGAN_UART_BASE

#define UART0_INT           	64+25
#define UART1_INT        	64+26

#ifdef CONFIG_SERIAL_MANY_PORTS
#define RS_TABLE_SIZE  64 
#else 
#define RS_TABLE_SIZE  2
#endif

/* Rate for the 3.6864 Mhz clock for the onboard serial chip */
#define BASE_BAUD 		( 3686400 / 16 )

#ifdef CONFIG_SERIAL_DETECT_IRQ
#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST|ASYNC_AUTO_IRQ)
#else
#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST)
#endif

#define STD_UART_OP(num)                                        \
        { 0, BASE_BAUD, 0, UART##num##_INT, STD_COM_FLAGS,  	\
                iomem_base: ARGAN_UART##num##_IO_BASE,                \
                io_type: SERIAL_IO_MEM},

#define SERIAL_PORT_DFNS        \
        STD_UART_OP(0)          \
        STD_UART_OP(1)

#endif /* __PPC_PLATFORMS_ARGAN_SERIAL_H */
