/*************************************************************************

Title:   	
Filename:   $Header: /opt/cvs/linux-2.4.20_mvl31/drivers/mtd/nand/mx2_nand.h,v 1.1 2005/07/07 22:02:39 andyg Exp $
Hardware:   MX21
Summay:

License:    The contents of this file are subject to the Mozilla Public
	    License Version 1.1 (the "License"); you may not use this file
	    except in compliance with the License. You may obtain a copy of
	    the License at http://www.mozilla.org/MPL/

Author:
Company:    Motorola Suzhou Design Center

====================Change Log========================
$Log: mx2_nand.h,v $
Revision 1.1  2005/07/07 22:02:39  andyg
picking up a bunch of updates from montavista....hope this works!

Revision 1.1.2.1  2004/06/17 10:48:26  yadviga
MR:5397
8/16 bit mx2 nand flash driver


file 	    mx2_nand.h
brief	    head file of MX21 NAND Flash Control low level.

author	    Frank Li(zhili@motorola.com)
version	    $Version$
********************************************************************************/

#ifndef MX_mx2_nand_INCLUDE
#define MX_mx2_nand_INCLUDE

#define ECC_EN 0x8
#define SP_EN  0x4

#define NAND_FLASH_CONFIG2_INT 0x8000
#define NAND_FLASH_CONFIG2_FCMD 0x1
#define NAND_FLASH_CONFIG2_FADD 0x2
#define NAND_FLASH_CONFIG2_FDI  0x4

#define ERR_TIME_OUT -1
#define ERR_VERIFY   -2

#define CONFIG2_SET_FDO_PAGE_OUT() NFC_NF_CONFIG2=0x8;
#define CONFIG2_SET_FDO_ID() 	  NFC_NF_CONFIG2=0x10
#define CONFIG2_SET_FDO_STATUS()  NFC_NF_CONFIG2=0x20;

#define CONFIG1_SET_READ() do{ NFC_NF_CONFIG1|=0x2; NFC_NF_CONFIG1&=~0x1;}while(0)
#define CONFIG1_SET_WRITE() do{ NFC_NF_CONFIG1&=~0x2; NFC_NF_CONFIG1|=0x1;}while(0)

#define NAND_CMD_READ2                      0x50
#define NAND_CMD_PAGE_PROG                  0x80
#define NAND_CMD_PAGE_PROG_CONFIRM_TRUE     0x10
#define NAND_CMD_PAGE_PROG_CONFIRM_DUMMY    0x11
#define NAND_CMD_BLOCK_ERASE                0x60
#define NAND_CMD_BLOCK_ERASE_CONFIRM        0xD0
#define NAND_CMD_READ_STATUS                0x70
#define NAND_CMD_READ_ID                    0x90

#define NAND_FLASH_BLOCK_NUMBER             4096*64
#define NAND_FLASH_PAGE_PER_BLOCK           32
#define NAND_FLASH_PAGE_MAIN_SIZE           512
#define	NAND_FLASH_PAGE_SPARE_SIZE          16

#define READCMD                             1
#define READBUF                             2

#endif
